"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Field = void 0;
const descriptors_1 = require("../descriptors");
function Field(...args) {
    let target;
    let name;
    let params = {};
    let propertyDescriptor;
    args.length === 1
        ? [params] = args
        : [target, name, propertyDescriptor] = args;
    function Field(target, name, propertyDescriptor) {
        var _a;
        if (propertyDescriptor)
            throw new Error("Cannot use the Field decorator on a method");
        (_a = params.name) !== null && _a !== void 0 ? _a : (params.name = name);
        const field = new descriptors_1.FieldDescriptor(params);
        let model = Reflect.getMetadata("model:descriptor", target);
        if (!model) {
            model = new descriptors_1.ModelDescriptor(target);
            Reflect.defineMetadata("model:descriptor", model, target);
        }
        model.add(field);
    }
    if (target)
        return Field(target, name, propertyDescriptor);
    else
        return Field;
}
exports.Field = Field;
