"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const descriptors_1 = require("../descriptors");
const field_1 = require("./field");
const model_1 = require("./model");
describe('Field', () => {
    it('should create a model descriptor', () => {
        let Foo = class Foo {
        };
        __decorate([
            field_1.Field,
            __metadata("design:type", String)
        ], Foo.prototype, "bar", void 0);
        Foo = __decorate([
            model_1.Model
        ], Foo);
        const d = Reflect.getMetadata("model:descriptor", Foo);
        expect(d).toBeInstanceOf(descriptors_1.ModelDescriptor);
        expect(d.name).toBe('Foo');
    });
    it('should create a field descriptor', () => {
        let Foo = class Foo {
        };
        __decorate([
            field_1.Field,
            __metadata("design:type", String)
        ], Foo.prototype, "bar", void 0);
        Foo = __decorate([
            model_1.Model
        ], Foo);
        const d = Reflect.getMetadata("model:descriptor", Foo);
        expect(d.fields.length).toBe(1);
        expect(d.fields.has('bar')).toBe(true);
    });
    it('should create multiple field descriptors', () => {
        let Foo = class Foo {
        };
        __decorate([
            field_1.Field,
            __metadata("design:type", String)
        ], Foo.prototype, "bar", void 0);
        __decorate([
            field_1.Field,
            __metadata("design:type", String)
        ], Foo.prototype, "baz", void 0);
        Foo = __decorate([
            model_1.Model
        ], Foo);
        const d = Reflect.getMetadata("model:descriptor", Foo);
        expect(d.fields.length).toBe(2);
        expect(d.fields.has('bar')).toBe(true);
        expect(d.fields.has('baz')).toBe(true);
    });
    it('should create multiple models', () => {
        let Foo = class Foo {
        };
        __decorate([
            field_1.Field,
            __metadata("design:type", String)
        ], Foo.prototype, "bar", void 0);
        __decorate([
            field_1.Field,
            __metadata("design:type", String)
        ], Foo.prototype, "baz", void 0);
        Foo = __decorate([
            model_1.Model
        ], Foo);
        let Goo = class Goo {
        };
        __decorate([
            field_1.Field,
            __metadata("design:type", String)
        ], Goo.prototype, "car", void 0);
        __decorate([
            field_1.Field,
            __metadata("design:type", String)
        ], Goo.prototype, "caz", void 0);
        __decorate([
            field_1.Field,
            __metadata("design:type", Number)
        ], Goo.prototype, "cuz", void 0);
        Goo = __decorate([
            model_1.Model
        ], Goo);
        const d = Reflect.getMetadata("model:descriptor", Foo);
        expect(d).toBeInstanceOf(descriptors_1.ModelDescriptor);
        expect(d.fields.length).toBe(2);
        expect(d.fields.has('bar')).toBe(true);
        expect(d.fields.has('baz')).toBe(true);
        const e = Reflect.getMetadata("model:descriptor", Goo);
        expect(e).toBeInstanceOf(descriptors_1.ModelDescriptor);
        expect(e.fields.length).toBe(3);
        expect(e.fields.has('car')).toBe(true);
        expect(e.fields.has('caz')).toBe(true);
        expect(e.fields.has('cuz')).toBe(true);
    });
});
