"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.override = void 0;
const meta_1 = require("../meta");
function override(target, name, descriptor) {
    if (descriptor) {
        // get the value of the method
        const value = descriptor.value;
        // set the method value to null on the object so that it is 
        // not set as the default implementation
        Object.defineProperty(target, name, {
            value: undefined,
            writable: true,
            enumerable: false
        });
        (0, meta_1.meta)(target).method(name).override(value);
    }
    else {
        (0, meta_1.meta)(target).property(name).override(true);
    }
}
exports.override = override;
