"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.meta = void 0;
const descriptors_1 = require("./descriptors");
/**
 * Get the ObjectDescriptor for an object or class, creates a new
 * ObjectDescriptor if one does not already exist.
 *
 * @param target Object or class to get descriptor for
 */
function meta(target) {
    if (typeof target === "function")
        target = target.prototype;
    if (!target.hasOwnProperty('Δmeta')) {
        Object.defineProperty(target, 'Δmeta', {
            value: new descriptors_1.ObjectDescriptor(target),
            writable: false,
            enumerable: false
        });
    }
    return target['Δmeta'];
}
exports.meta = meta;
