"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Model = void 0;
const descriptors_1 = require("../descriptors");
require("reflect-metadata");
function Model(...args) {
    let target;
    let params;
    if (args.length) {
        args[0] instanceof Function
            ? [target] = args
            : [params] = args;
    }
    function Model(target) {
        var _a;
        // A stub model descriptor may have been created by a @Field decorator
        let descriptor = Reflect.getMetadata("model:descriptor", target.prototype);
        if (descriptor) {
            // Copy in params
            if (params)
                Object.assign(descriptor, params);
            else
                (_a = descriptor.name) !== null && _a !== void 0 ? _a : (descriptor.name = target.name);
            // Autopopulate empty label/token values
            descriptor.autopopulate();
        }
        else {
            if (params) {
                params = Object.assign(Object.assign({}, params), { name: target.name });
                descriptor = new descriptors_1.ModelDescriptor(params);
            }
            else {
                descriptor = new descriptors_1.ModelDescriptor(target.name);
            }
        }
        Reflect.defineMetadata("model:descriptor", descriptor, target);
    }
    if (target)
        return Model(target);
    else
        return Model;
}
exports.Model = Model;
Model.descriptor = function (model) {
    return Reflect.getMetadata("model:descriptor", model);
};
