"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.build = void 0;
const meta_1 = require("../meta");
function build(method, ...args) {
    function build(target, name, descriptor) {
        if (descriptor)
            throw new Error("Cannot use the build decorator on a method");
        if (method === undefined)
            method = `_build_${name}`;
        (0, meta_1.meta)(target).property(name).default(o => o[method].call(o, o));
    }
    if (method instanceof Object) {
        let [target, name, descriptor] = [method, ...args];
        method = undefined;
        return build(target, name, descriptor);
    }
    else {
        return build;
    }
}
exports.build = build;
