"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lazy = void 0;
const meta_1 = require("../meta");
/* This does the same thing as the 'property' decorator. */
function lazy(value, propertyName, descriptor) {
    function lazy(target, propertyName, descriptor) {
        if (descriptor)
            throw new Error("Cannot use the lazy decorator on a method");
        (0, meta_1.meta)(target).property(propertyName).default(value);
    }
    if (propertyName === undefined) {
        return lazy;
    }
    else {
        let target = value;
        value = undefined;
        return lazy(target, propertyName, descriptor);
    }
}
exports.lazy = lazy;
