"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.property = void 0;
const meta_1 = require("../meta");
/*
Does the same thing as lazy. This is due to the way in which properties are
implemented in javascript and how agape's property dispatcher works...

Really this should accept a default value. That would mean setting the 'value'
on the native property descriptor when it is created instead of the getter and the setter.
Or maybe just set the value directly on the prototype?

*/
function property(value) {
    return function property(target, propertyName, descriptor) {
        if (descriptor)
            throw new Error("Cannot use property decorator on a method");
        (0, meta_1.meta)(target).property(propertyName).default(value);
    };
}
exports.property = property;
