"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.stack = void 0;
const meta_1 = require("../meta");
function stack(target, name, descriptor) {
    // get the value of the method
    const value = descriptor.value;
    // set the method value to null on the object so that it is 
    // not set as the default implementation
    Object.defineProperty(target, name, {
        value: null,
        writable: true,
        enumerable: false
    });
    // stack it up
    (0, meta_1.meta)(target).method(name).stack(value);
}
exports.stack = stack;
