import { Class, Dictionary } from "./types";
export declare class Serializer {
    to?: Class;
    constructor(to?: Class);
    inflate(data: any): any;
    deflate(item: Object, params?: any): any;
}
/**
 * Inflate
 */
export declare function inflate<T extends Class>(to: T, from: Dictionary | any): InstanceType<T>;
export declare function inflate<T extends Class>(to: [T], from: Dictionary[] | any[]): Array<InstanceType<T>>;
export declare function inflate<T>(to: Class | Serializer, from: Dictionary): T;
export declare function inflate<T>(to: [Class] | [Serializer], from: Dictionary[]): T;
export declare function inflateObject<T>(to: Class | Serializer, from: Dictionary): T;
export declare function inflateArray<T>(to: Class | Serializer, from: Dictionary[]): T[];
/**
 * Deflate
 */
export declare function deflate(item: any, params?: any): any;
